package cz.matejkripner;

import cz.matejkripner.user.MainWindow;
import javafx.application.Application;
import javafx.scene.image.Image;
import javafx.stage.Stage;

/**
 * Entry point of the application. Used to st up the primary stage.
 *
 * @author Matej Kripner <kripnermatej@gmail.com>
 * @version 1.0
 */
public class Main extends Application {

    private static final String ICON_NAME = "icon.ico";
    private static final String TITLE = "Lion Internet Meter";
    private static final int HEIGHT = 400;
    private static final int WIDTH = 550;

    public static void main(String[] args) {
        launch(args);
    }

    @Override
    public void start(Stage primaryStage) throws Exception {
        MainWindow mainWindow = new MainWindow();
        primaryStage.setScene(mainWindow.getScene());
        initStage(primaryStage);
        primaryStage.show();
    }

    private void initStage(Stage stage) {
        stage.setHeight(HEIGHT);
        stage.setWidth(WIDTH);
        stage.setResizable(false);
        stage.setTitle(TITLE);
        stage.getIcons().add(new Image("file:" + ICON_NAME));
    }
}
