package cz.matejkripner.services;

/**
 * Should be thrown when an error with measuring occur.
 *
 * @author Matej Kripner <kripnermatej@gmail.com>
 * @version 1.0
 */
public class MeasurementException extends RuntimeException {
    private final boolean fatal;

    public MeasurementException(String message, boolean fatal, Throwable cause) {
        super(message, cause);
        this.fatal = fatal;
    }

    public MeasurementException(String message, boolean fatal) {
        super(message);
        this.fatal = fatal;
    }

    public MeasurementException(String message) {
        this(message, true);
    }

    /**
     * Return if this error cause that the measuring has to be stopped.
     *
     * @return if this error cause that the measuring has to be stopped
     */
    public boolean isFatal() {
        return fatal;
    }
}
