import java.io.IOException;

public class TestManager {
	
	public String sizeOfTestedFile;
	private byte testAccuracy;
	private boolean badData;
	
	InOutHelper inOutHelper;
	Tests tests;
	
	public TestManager(InOutHelper inOutHelper)
	{
		this.inOutHelper = inOutHelper;
		badData = false;
	}
	
	public void Run()
	{
		inOutHelper.WriteLn("Vitajte v programe NetBenchmark 1.0!\n================================");
		
		boolean reRun = true;
		while(reRun)
		{
			try
			{
				GetInfo();
				if (!badData)
				{
					reRun = true;
					tests = new Tests(testAccuracy);
					Test();
				
					inOutHelper.WriteLn("Chcete test zopakova(a/n): ");
					if (!inOutHelper.ReadLn().equals("a"))
						reRun = false;
				}
				else
				{
					inOutHelper.WriteLn("Zadali ste nesprvne daje, chcete zadvanie zopakova(a/n): ");
					if (!inOutHelper.ReadLn().equals("a"))
						reRun = false;
				}
			}
			catch (Exception e)
			{
				inOutHelper.WriteLn(e.toString());
			}
		}
	}
	
	private void GetInfo()
	{
		inOutHelper.WriteLn("Vyberte prosm vekos sboru (mal - m, stredn - s, vek - v): ");
		String size = inOutHelper.ReadLn();
		if (size.equals("m"))
		{
			sizeOfTestedFile = "small";	
		}
		else if (size.equals("s"))
		{
			sizeOfTestedFile = "medium";
		}
		else if (size.equals("v"))
		{
			sizeOfTestedFile = "big";
		}
		else
			badData = true;
		
		inOutHelper.WriteLn("Vyberte prosm poet testov(1-10): ");
		byte accuracy = Byte.parseByte(inOutHelper.ReadLn());
		if (accuracy > 0 && accuracy <= 10)
			testAccuracy = accuracy;
		else
			badData = true;
	}
	
	private void Test() throws IOException, InterruptedException 
	{
		inOutHelper.WriteLn("Test odozvy serveru");
		
		for (int i = 0; i < testAccuracy; i++)
			inOutHelper.WriteLn(String.format("%d.Test odozvy: %d ms", i + 1, tests.PingTest(i)));
		
		inOutHelper.WriteLn(String.format("Priemern as odozvy: %s", Average(tests.pingTests, false)));
		
		inOutHelper.WriteLn("Test Sahovanie/Nahrvanie");
		for (int i = 0; i < testAccuracy; i++)
		{
			String downloadSpeed = tests.DownloadTest(sizeOfTestedFile, i);
			inOutHelper.WriteLn(String.format("%d.Test rchlosti sahovania: %s", i + 1, downloadSpeed));
			String uploadSpeed = tests.UploadTest(sizeOfTestedFile, i);
			inOutHelper.WriteLn(String.format("%d.Test rchlosti nahrvania: %s", i + 1, uploadSpeed));
		}
		
		inOutHelper.WriteLn(String.format("\nPrimern rchlos sahovania: %s", Average(tests.downloadSpeeds, true)));
		inOutHelper.WriteLn(String.format("Priemern rchlos nahrvania: %s", Average(tests.uploadSpeeds, true)));
	}
	
	private String Average(float[] speeds, boolean IsSpeed)
	{
		float average = 0;
		for (float speed : speeds)
		{
			average += speed;
		}
		
		if (average / speeds.length < 1000 && IsSpeed)
			return String.format("%.2f Kb/s", Math.round((average / speeds.length) * 100.0f) / 100.0f);
		else if (average / speeds.length >= 1000 && IsSpeed)
			return String.format("%.2f Mb/s", Math.round(((average / speeds.length) / 1024) * 100.0f) / 100.0f);
		else
			return String.format("%d ms", Math.round(average / speeds.length));
	}
}
